# #
# $Date: 1996/06/20 12:17:35 $  $Author: frankp $   $Revision: 1.17 $ #
# #
# frankp, 21/02/94 #

#++
  rank.mu

	linalg::rank - compute the rank of a matrix over an 
	               integral domain

	rank( A )
	rank( S )

	A - matrix over an integral domain
	S - set or list of vectors defined over an integral domain

	rank(A) computes the rank of A.
	rank(S) computes the rank of the matrix which has
	the vectors in S as its columns.
++#

linalg::rank := fun(
    (if testargs() then
	if args(0) <> 1 then error("wrong no of args") end_if;
        if (args(1))::hasProp( Cat::MatrixCat ) <> TRUE then
	    case domtype(args(1))
	    of DOM_SET do
		if nops(args(1)) = 0 then break end_if;	
		op(args(1),1);
		if ((last(1))::coeffRing)::hasProp(Cat::IntegralDomain) <> TRUE then
                    error("expecting vectors over an integral domain")
		elif not testtype( args(1),Type::SetOf( linalg::VectorOf(
		  (last(1))::coeffRing,nops(last(1))
		 )) ) then
		    error("incompatible vectors")
		end_if;
		break
	    of DOM_LIST do
		if nops(args(1)) = 0 then break end_if;
		op(args(1),1);
		if ((last(1))::coeffRing)::hasProp(Cat::IntegralDomain) <> TRUE then
		    error("expecting vectors over an integral domain")
		elif not testtype( args(1),Type::ListOf( linalg::VectorOf(
		  (last(1))::coeffRing,nops(last(1))
		)) ) then
                    error("incompatible vectors")
                end_if;
		break
	    otherwise
	        error("expecting a matrix or a set or list of vectors")
	    end_case
	elif not ((args(1))::coeffRing)::hasProp(Cat::IntegralDomain) then
	    error("expecting matrix over an integral domain")
	end_if
    end_if;

    if domtype(args(1)) = DOM_LIST or domtype(args(1)) = DOM_SET then
	if nops(args(1)) = 0 then 0
	else op( (op(args(1),1))::gaussElim(_concat(op(args(1)))),2 )
	end_if
    else
	op( (args(1))::gaussElim(args(1)),2 )
    end_if
)):

# end of file #
